diff a/src/hotspot/share/oops/resolvedFieldEntry.cpp b/src/hotspot/share/oops/resolvedFieldEntry.cpp
--- a/src/hotspot/share/oops/resolvedFieldEntry.cpp
+++ b/src/hotspot/share/oops/resolvedFieldEntry.cpp
@@ -21,11 +21,12 @@
  * questions.
  *
  */
 
 #include "precompiled.hpp"
-#include "resolvedFieldEntry.hpp"
+#include "cds/archiveBuilder.hpp"
+#include "oops/resolvedFieldEntry.hpp"
 
 void ResolvedFieldEntry::print_on(outputStream* st) const {
   st->print_cr("Field Entry:");
 
   if (field_holder() != nullptr) {
@@ -46,5 +47,9 @@
 void ResolvedFieldEntry::remove_unshareable_info() {
   u2 saved_cpool_index = _cpool_index;
   memset(this, 0, sizeof(*this));
   _cpool_index = saved_cpool_index;
 }
+
+void ResolvedFieldEntry::mark_and_relocate() {
+  ArchiveBuilder::current()->mark_and_relocate_to_buffered_addr(&_field_holder);
+}
